=== debian/changelog ===
minc (2.2.00-6) unstable; urgency=medium

  * Apply two patches fixing Mahem test issues.  Thanks to Martin
    Steghöfer <martin@steghoefer.eu>
    Closes: #716511, #716616
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Mon, 06 Oct 2014 09:49:50 +0200

minc (2.2.00-5) unstable; urgency=medium

  [ Gilles Filippini ]
  * rules: Support hdf5 1.8.13 new packaging layout.  Closes: #756684.

 -- Steve M. Robbins <smr@debian.org>  Sat, 02 Aug 2014 12:06:50 -0500

minc (2.2.00-4) unstable; urgency=medium

  * Apply patch provided by Alexander Ovchinnikov to build with clang
    (thanks to Alexander)
    Closes: 741744
  * cme fix dpkg-control
  * debian/copyright: DEP5

 -- Andreas Tille <tille@debian.org>  Mon, 05 May 2014 11:21:48 +0200

minc (2.2.00-3) unstable; urgency=low

  * patches/maxpathlen.patch: New.  Work around missing MAXPATHLEN on
    hurd.

 -- Steve M. Robbins <smr@debian.org>  Sat, 14 Sep 2013 00:39:06 -0500

minc (2.2.00-2) unstable; urgency=low

  * patches/pod_fix.diff: New.  Fix POD documentation to comply with
    stricter parsing of perl 5.18.  Closes: #719502.

  * rules: disable parallel build; causes tests to fail inexplicably.
  
 -- Steve M. Robbins <smr@debian.org>  Fri, 13 Sep 2013 23:22:53 -0500

minc (2.2.00-1) unstable; urgency=low

  * New upstream.
  * patches/hdfv2-fixes.patch: Remove.  Applied upstream.

  * patches/makefile.patch: New.  Fix build failure.
  * patches/acrnema-version.patch: New.  Add proper versioning to
    libacr_nema.

  * rules: Use "--with autoreconf" since new patches affect Makefile.am.

  * rules:  
  * control: SOVERSION bump to 3; new package name libminc2-3.

 -- Steve M. Robbins <smr@debian.org>  Sat, 13 Oct 2012 23:09:25 -0500
