=== debian/control ===
Source: minc
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               autotools-dev,
               dh-autoreconf,
               libnetcdf-dev,
               zlib1g-dev,
               texlive-latex-base,
               libhdf5-dev
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/minc/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/minc/trunk/
Homepage: http://www.bic.mni.mcgill.ca/ServicesSoftware/HomePage

Package: minc-tools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         netcdf-bin,
         libgetopt-tabular-perl,
         libtext-format-perl,
         imagemagick
Description: MNI medical image format tools
 This package contains tools to manipulate MINC files.
 .
 The Minc file format is a highly flexible medical image file format
 built on top of the NetCDF generalized data format. The format is
 simple, self-describing, extensible, portable and N-dimensional, with
 programming interfaces for both low-level data access and high-level
 volume manipulation. On top of the libraries is a suite of generic
 image-file manipulation tools. The format, libraries and tools are
 designed for use in a medical-imaging research environment: they are
 simple and powerful and make no attempt to provide a pretty interface
 to users.

Package: libminc2-3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: MNI medical image format library
 This package contains the libraries libminc2 and libvolume_io2.
 .
 The Minc file format is a highly flexible medical image file format.
 Minc version 1 is built on top of the NetCDF generalized data format. 
 Minc version 2 is built on top of the HDF data format.  This library
 handles both formats.  In each case the format is
 simple, self-describing, extensible, portable and N-dimensional, with
 programming interfaces for both low-level data access and high-level
 volume manipulation. On top of the libraries is a suite of generic
 image-file manipulation tools. The format, libraries and tools are
 designed for use in a medical-imaging research environment : they are
 simple and powerful and make no attempt to provide a pretty interface
 to users.

Package: libminc-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libminc2-3 (= ${binary:Version}),
         libnetcdf-dev,
         libhdf5-dev
Conflicts: libminc0-dev
Replaces: libminc0-dev
Description: MNI medical image format development environment
 This package contains the library and headers for libminc2 and
 libvolume_io2.
 .
 The Minc file format is a highly flexible medical image file format.
 Minc version 1 is built on top of the NetCDF generalized data format. 
 Minc version 2 is built on top of the HDF data format.  This library
 handles both formats.  In each case the format is
 simple, self-describing, extensible, portable and N-dimensional, with
 programming interfaces for both low-level data access and high-level
 volume manipulation. On top of the libraries is a suite of generic
 image-file manipulation tools. The format, libraries and tools are
 designed for use in a medical-imaging research environment : they are
 simple and powerful and make no attempt to provide a pretty interface
 to users.
